import java.applet.*;
import java.awt.*;

	/*
	Anyway. This is my bit for Java toy-making. I am Neal McDonald,
	this is my code, take and eat, but leave in a pointer to me:
	www.workly.com
	*/

public class flow extends water {

	// 	first, declare constants for array sizes and indexing
	static int XVEL=12;			// velocity
	static int YVEL=13;
	static int CHARGE = 14;	// how likely are you to move? 
	static int RANGE = 15;		// how likely are you to move? 
	static int MODE = 16;			// 1=>flow-er -1=>field emitter
	
	static int	R = 17;
	static int	G = 18;
	static int	B = 19;
	
	double friction = 0.98; 
	double maxSpeed = 140.0;
	double gravity = 2.0;
	double timeStep = 0.05;
	double partRadius = 20.0;
	
	double colorLimit = 80.0;

	int numFields;	

	// //////////////////////////////////////////////////////////////////
	// end global data; begin functions to override 
	// //////////////////////////////////////////////////////////////////


	
	void initPart(int which) {
		int i, r, g, b;
		Color ac;
		
		if (which>=numFields) {
			// standard init 
			parts[which][XPOS] = ((MAX_X-MIN_X) * Math.random()) + MIN_X;
			parts[which][YPOS] = ((MAX_Y-MIN_Y) * Math.random()) + MIN_Y;
			parts[which][OX] = parts[which][XPOS];
			parts[which][OY] = parts[which][YPOS];
			parts[which][YVEL] = 0.0;
			parts[which][YVEL] = 0.0;
			parts[which][RANGE] = 300.0 *  Math.random() + 100.0;
			parts[which][CHARGE] = 5.0* Math.random()+ 2.0;
			parts[which][MODE] = Math.random() * 100.0;
		} else {
			// init a field emitter
			parts[which][XPOS] = ((MAX_X-MIN_X) * Math.random()) + MIN_X;
			parts[which][YPOS] = ((MAX_Y-MIN_Y) * Math.random()) + MIN_Y;
			parts[which][YVEL] = 0.0;
			parts[which][YVEL] = 0.0;
			parts[which][RANGE] = 300.0 *  Math.random() + 100.0;
			parts[which][CHARGE] = 300.0 *  Math.random() + 200.0;
			parts[which][MODE] = -1.0;
		}	
		
		ac = getColorC((int)parts[which][XPOS], (int)parts[which][YPOS]);
		parts[which][R] = ac.getRed();
		parts[which][G] = ac.getGreen();
		parts[which][B] = ac.getBlue();
		partColors[which] = ac;
	}
	

	
	void drawPart(Graphics g, int which) {
		int centerX, centerY, ox, oy, r, rx, ry;
		Color ac= new Color(((int)parts[which][R]), ((int)parts[which][G]), ((int)parts[which][B]));
		g.setColor(ac);
	
		centerX = (int)parts[which][XPOS];
		centerY = (int)parts[which][YPOS];
		ox = (int)parts[which][OX];
		oy = (int)parts[which][OY];

		
		if (parts[which][MODE]>0.0) {	
			if (parts[which][MODE]>colorLimit) { 
				//rx = (int)(((MAX_X-MIN_X) * Math.random()) + MIN_X);
				//ry = (int)(((MAX_Y-MIN_Y) * Math.random()) + MIN_Y);
				partColors[which] = getColorC(ox, oy); 
				g.setColor(partColors[which]);
			}
			r = (int)partRadius;
			if (parts[which][JUMPED]<0.1) { g.drawLine(centerX, centerY, ox,oy); } 
		} 
	}




	
	// state updates to be carried out once per simulation tick 
	void forceForPart(int which) {
		int j, targ;
		double dx, dy, s, d;
			
		if (parts[which][MODE]<colorLimit) {
			parts[which][R] *= 0.95;
			parts[which][G] *= 0.95;
			parts[which][B] *= 0.95;
		}
		
		// add forces from all mode-1's
		if (parts[which][MODE]>0.0) { // for each flowpart
			for (j=0; j<NUM_PARTS; ++j) {
				if ((j!=which)&&(parts[j][MODE]<0.0)) { // exert forces
					// d = vector from j to which 
					dx = parts[which][XPOS] - parts[j][XPOS];
					dy = parts[which][YPOS] - parts[j][YPOS];
					d = (double)Math.sqrt(dx*dx+dy*dy);
					// d = dx*dx+dy*dy;
	
					if (d < parts[j][RANGE]) {
						s = parts[j][CHARGE] / (d*d);
						parts[which][XVEL] += dy*s;
						parts[which][YVEL] -= dx*s;
					}
				}
				if ((j!=which)&&(parts[j][MODE]>colorLimit)) { // exert color
					// d = vector from j to which 
					dx = parts[which][XPOS] - parts[j][XPOS];
					dy = parts[which][YPOS] - parts[j][YPOS];
					d = (double)Math.sqrt(dx*dx+dy*dy);
					
					s = parts[j][CHARGE] / (d*d);
					parts[which][R] += s * parts[j][R];
					parts[which][G] += s * parts[j][G];
					parts[which][B] += s * parts[j][B];
					if (parts[which][R]>255.0) { parts[which][R] = 255.0; }
					if (parts[which][G]>255.0) { parts[which][G] = 255.0; }
					if (parts[which][B]>255.0) { parts[which][B] = 255.0; }
					
				}
			}
	
			// air drag
			parts[which][XVEL] *= friction;
			parts[which][YVEL] *= friction;
	
			// gravity!
			parts[which][YVEL] += gravity;
	
			// hey. no running.
			if (parts[which][XVEL] < (-maxSpeed)) parts[which][XVEL] = -maxSpeed;
			if (parts[which][YVEL] < (-maxSpeed)) parts[which][YVEL] = -maxSpeed;
			if (parts[which][XVEL] > maxSpeed) parts[which][XVEL] = maxSpeed;
			if (parts[which][YVEL] > maxSpeed) parts[which][YVEL] = maxSpeed;
		} else {
			parts[which][XVEL] = 0.0;
			parts[which][YVEL] = 0.0;
		}
	}
	




	// state updates after forces; does constraint enforcement
	void collidePart(int which) {
		int j;
		double dx, dy, d, vx, vy, rv, s;
	
		// since we know we're calling this from a for i=0 to N_P loop,
		for (j=which+1; j<NUM_PARTS; j++) {
			// and change both which and j -- cuts sqrt's by 1/2
			
			// d = vector from j to which 
			dx = parts[which][XPOS] - parts[j][XPOS];
			dy = parts[which][YPOS] - parts[j][YPOS];
			d = (double)Math.sqrt(dx*dx+dy*dy);
			// d = dx*dx+dy*dy;

			if (d < (partRadius*0.8)) {
				// elastic collisions exchange velocities
				vx = parts[which][XVEL];
				vy = parts[which][YVEL];
				parts[which][XVEL] = parts[j][XVEL];
				parts[which][YVEL] = parts[j][YVEL];
				parts[j][XVEL] = vx;
				parts[j][YVEL] = vy;
				
				s = (((partRadius)-d)/2.0)/d;
				
				parts[j][XPOS] -= dx*s;
				parts[j][YPOS] -= dy*s;
				parts[which][XPOS] += dx*s;
				parts[which][YPOS] += dy*s;
			}
		}
		
		// toroidal wrap for x? not in this one.
		
		parts[which][JUMPED] = 0.0;
		if (parts[which][XPOS] < 0.0) { 
			parts[which][XPOS] = MAX_X; 
			parts[which][JUMPED] = 1.0;
		}
		if (parts[which][XPOS] > MAX_X) { 
			parts[which][XPOS] = 0.0; 
			parts[which][JUMPED] = 1.0;
		}
				
		if (parts[which][YPOS] < 0.0) { 
			parts[which][YPOS] = MAX_Y; 
			parts[which][JUMPED] = 1.0;
		}
		if (parts[which][YPOS] > MAX_Y) { 
			parts[which][YPOS] = 0.0; 
			parts[which][JUMPED] = 1.0;
		}
	
		if (parts[which][MODE]<0.0) {
			parts[which][XVEL] = 0.0;
			parts[which][YVEL] = 0.0;
		}

	}
	

	void doMove(int howMany) {
		int i;
		if ((mouseStop==0) && (slowdownCounter<1)) {
			for (i=0; i<NUM_PARTS; ++i) {
				forceForPart(i);
			}

			for (i=0; i<NUM_PARTS; ++i) {
				parts[i][OX] = parts[i][XPOS];
				parts[i][OY] = parts[i][YPOS];
			
				parts[i][XPOS] += parts[i][XVEL] * timeStep;
				parts[i][YPOS] += parts[i][YVEL] * timeStep;
			}

			// register bouncing, collisions
			for (i=0; i<NUM_PARTS; ++i) {
				collidePart(i);
			}
			++simTicks;
			slowdownCounter = slowdownFactor; 
		} else {
			--slowdownCounter;
		}
	}
	
	
	void initMore() {
		numFields = java.lang.Integer.parseInt(getParameter("numFields"));
		timeStep = 0.001 * (double)(java.lang.Integer.parseInt(getParameter("timeStep")));
		gravity = 0.01 * (double)(java.lang.Integer.parseInt(getParameter("gravity")));
		friction = 0.001 * (double)(java.lang.Integer.parseInt(getParameter("friction")));
		maxSpeed = 0.1 * (double)(java.lang.Integer.parseInt(getParameter("maxSpeed")));
		partRadius = 0.1 * (double)(java.lang.Integer.parseInt(getParameter("radius")));
	}
	
}

